// ---------------------------------------------------------------------------
// am_repair.cs -- Version 2.4 -- April 28, 1999
// by Lorne Laliberte (Writer -- writer@videon.wave.ca)
//
// http://www.planetstarsiege.com/lorne/
// ---------------------------------------------------------------------------

include("other\\am_trigger.cs");
include("other\\flood.cs");


$AutoMessage::FilterItem[0] = "Scout";
$AutoMessage::FilterItem[1] = "LPC";
$AutoMessage::FilterItem[2] = "HPC";
$AutoMessage::FilterCount = 3;
$AutoMessage::FilterModeOn = true; // enable filters by default



//
// Check for "Repairing " messages
//
function AutoMessage::StartingRepairs(%msg)
{
    if( (%index = String::findSubStr(%msg, "Repairing ")) != -1)
    {
        // Set %index to next character after "Repairing "
        %index += 10;

        // What are you repairing?
        $AutoMessage::FloodItem = $AutoMessage::RepairItem = String::getSubStr(%msg, %index, 1024); // get rest of %msg from %index

        // Don't say anything if we're repairing a teammate (or an enemy lol :) -- thanks to Poker and Presto for this
		if (getClientByName($AutoMessage::RepairItem) != 0)
			return true;

        // Set a flag to enable our Repairs Completed code
        $AutoMessage::Repairing = 1;

        // Ignore the "#1" etc in item name for purposes of comparison and flood protection
        if( (%index = String::findSubStr($AutoMessage::RepairItem, "#")) != -1)
        {
            $AutoMessage::FloodItem = String::getSubStr($AutoMessage::RepairItem, 0, %index - 1);
        }

        if(Flood::protect("repair" @ $AutoMessage::FloodItem) && Flood::protect("repairdone" @ $AutoMessage::FloodItem))
        {
            // Some people don't like hearing when I repair certain things --
            // as important as I think it is they know I'm repairing my trusty
            // scout, I try to be accomodating :)
            $AutoMessage::Filter = false;
            if($AutoMessage::FilterModeOn) 
            {
                // Should we filter (not announce repairs on) this item?
                for(%i = 0; %i < $AutoMessage::FilterCount; %i++)
                {
                    if(String::ICompare($AutoMessage::FloodItem, $AutoMessage::FilterItem[%i]) == 0)
                    {
                        $AutoMessage::Filter = true; // set flag so we won't say item's repaired when done
                        return true;
                    }
                }
            }

            // Tell the team what you're repairing -- if you change the text, make
            // sure you don't use the word "repairing" at all, or you will trigger
            // this code over and over and get spam-blocked. :)
            say(1, "Repair begun on " @ $AutoMessage::RepairItem);
        }
        return true;
    }
    return false;
}
// Attach AutoMessage::StartingRepairs to the ladderClientMessage set up by am_trigger.cs
Event::Attach(ladderClientMessage, AutoMessage::StartingRepairs);


//
// Check for messages that indicate repair was interrupted
//
function AutoMessage::RepairInvalid(%msg)
{
	if( (String::findSubStr(%msg, "is not damaged") != -1) ||
	    (String::findSubStr(%msg, "AutoRepair Off") != -1) ||
	    (String::findSubStr(%msg, "Nothing in range") != -1) )
	{
	    if($MMB::Repairing)
            MMB::StopRepair();

        return true;
    }
    else if(String::findSubStr(%msg, "Repair Stopped") != -1)
    {
        // Turn on flood protection for this item
        Flood::protect("repair" @ $AutoMessage::FloodItem, 60);

	    if($MMB::Repairing)
            MMB::StopRepair();

        return true;
    }
    return false;
}
// Attach AutoMessage::RepairInvalid to the ladderClientMessage set up by am_trigger.cs
Event::Attach(ladderClientMessage, AutoMessage::RepairInvalid);


//
// Check for completed repairs message
//
function AutoMessage::RepairDone(%msg)
{
    if($AutoMessage::Repairing)
    {
        if((String::findSubStr(%msg, "Done") != -1))
        {
            if(Flood::protect("repairdone" @ $AutoMessage::FloodItem, 60))
            {
                if(!$AutoMessage::Filter)
                {
                    // Tell the team what you've repaired:
                    say(1, $AutoMessage::RepairItem @ " has been repaired!");
                }
            }

            if($AutoMessage::PowerWasDown)
            {
                if( (String::findSubStr($AutoMessage::RepairItem, "Generator") != -1) || 
                    (String::findSubStr($AutoMessage::RepairItem, "Solar Panel") != -1) )
                {
                    say(1, "Our Power is Back Up!"); // only visible to teammates

                    $AutoMessage::PowerWasDown = false;
                }
            }

            // Clear flag so we don't spam with nonsense messages if someone says "Done"
            $AutoMessage::Repairing = 0;

            if($MMB::Repairing)
            {
                MMB::StopRepair();
            }
            return true;
        }
    }
    return false;
}
// Attach AutoMessage::RepairDone to the ladderClientMessage set up by am_trigger.cs
Event::Attach(ladderClientMessage, AutoMessage::RepairDone);