// ---------------------------------------------------------------------------
// pack_and_back.cs -- Version 1.13 -- April 9, 1999
// by Lorne Laliberte (VIS.Writer[SAB] -- writer@videon.wave.ca)
//
// http://www.planetstarsiege.com/lorne/
// ---------------------------------------------------------------------------



//
// Re-select the previously selected weapon when a repair pack
// is turned off -- also toggle "normal" packs on and off
//
function PackAndBack()
{
    %pack = getMountedItem(1);
    %weapon = getMountedItem(0);
  	if(%pack == $Inv::Repair_Pack)
  	{	
        // Repair packs replace the currently selected weapon
        // with the RepairGun, and are turned off by selecting
        // a different weapon

  	    if(%weapon == $Inv::Repair_Gun)
  	    {
            // Do we know what weapon was selected before?
            if($OldWeapon == "")
            {
                // No -- switch to next available weapon
                nextWeapon();
            }
            else
            {
                // Yes -- switch back to previously selected weapon
                use($OldWeapon);
            }
  	    }
  	    else
  	    {
            // Switch to the repair pack and remember which weapon
            // was selected so we can switch back to it later
      		$OldWeapon = $Inv::Name[%weapon];
            use("BackPack");
  	    }
  	}
  	else
  	{
        // Other packs are turned on and off with the use() function;
        // if we didn't have this else clause, it would take 2 keypresses
        // to toggle the non-repair packs on and off. :)
        
  	    // Toggle "normal" back packs on and off
  	    // (or deploy a deployable item pack)
  	    use("BackPack");
  	}
}


//
// Re-select the previously selected weapon (or the next available one)
// when a repair pack that is being used is dropped
//
function DropPack()
{
   	if(getMountedItem(0) == $Inv::Repair_Gun)
   	{
        // We're dropping a repair pack, which will leave us with
        // no weapon selected unless we select one, which we will :)

   	    // Drop the pack
        drop(BackPack);
        
        // Do we know what weapon was selected before?
        if($OldWeapon == "")
        {
            // No -- switch to next available weapon
            nextWeapon();
        }
        else
        {
            // Yes -- switch back to previously selected weapon
            use($OldWeapon);
        }
    }
    else
    {
        // It's not a repair pack we're dropping, so our
        // weapon is still selected (it has been all along)
        
        // Drop the pack
        drop(BackPack);
    }

}

// Bind to my default keys if keys.cs not used

    EditActionMap("playMap.sae"); 
    
    // Use backpack -- knows to toggle repair pack on/off

    bindCommand(keyboard0, make, "p", TO, "PackAndBack();");
    bindCommand(keyboard0, break, "p", TO, "");
    
    // Drop backpack
   
    bindCommand(keyboard0, make, control, "p", TO, "DropPack();");
    bindCommand(keyboard0, break, control, "p", TO, "");
